--[[
Chrystal Connect for Creative ZEN X-Fi2
This script and all sub-elements of this Lua Application were created by Tetrajak
This Lua Application and it's components are Creative Commons licensed; BY-NC-SA; (Attribution Non-Commercial Share Alike) by Tetrajak

http://creativecommons.org/licenses/by-nc-sa/3.0/

You are free:
	to Share - to copy, distribute and transmit this work
	to Remix - to adapt this work

Under the following conditions:
	Attribution - You must attribute the work to the creator in any description, readme, script header comment, any other means of description about the remixed work, or in a manner already used by the creator, in, with, or wherever the remixed work you have created is distributed (but not in any way that suggests that the creator endorses you or your use of this work).
	Noncommercial - You may not use this work for commercial purposes
	Share Alike - If you alter, transform, or build upon this work, you may distribute the resulting work only under the same or similar license to this one.

With the understanding that:
	Waiver - Any of the above conditions can be waived if you get permission from the copyright holder.
	Public Domain - Where this work or any of its elements is in the public domain under applicable law, that status is in no way affected by the license.
	Other Rights - In no way are any of the following rights affected by the license:
		> Your fair dealing or fair use rights, or other applicable copyright exceptions and limitations;
		> The author's moral rights;
		> Rights other persons may have either in the work itself or in how the work is used, such as publicity or privacy rights.
	Notice - For any reuse or distribution, you must make clear to others the license terms of this work. The best way to do this is with a link to this web page (http://creativecommons.org/licenses/by-nc-sa/3.0/).

http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode
]]--
version = "Version 1.0.0" -- current version
white = color.new(255,255,255)
black = color.new(0,0,0)
black50 = color.new(0,0,0,123)
text.size(16)
text.color(white)

image.setresource("res.bin") --set image resource
dialog = image.load("res/dialog.png") -- load ingame images
hintoff = image.load("res/hintoff.png")
hinton = image.load("res/hinton.png")
menu = image.load("res/menu.png")
soundoff = image.load("res/soundoff.png")
soundon = image.load("res/soundon.png")
splash = image.load("res/splash.png")
board = image.load("res/board.png")
gameover = image.load("res/gameover.png")
scorebar = image.load("res/scorebar.png")
blue = image.load("res/blue.png")
blues1 = image.load("res/blues1.png")
blues2 = image.load("res/blues2.png")
blues3 = image.load("res/blues3.png")
blues4 = image.load("res/blues4.png")
green = image.load("res/green.png")
greens1 = image.load("res/greens1.png")
greens2 = image.load("res/greens2.png")
greens3 = image.load("res/greens3.png")
greens4 = image.load("res/greens4.png")
orange = image.load("res/orange.png")
oranges1 = image.load("res/oranges1.png")
oranges2 = image.load("res/oranges2.png")
oranges3 = image.load("res/oranges3.png")
oranges4 = image.load("res/oranges4.png")
purple = image.load("res/purple.png")
purples1 = image.load("res/purples1.png")
purples2 = image.load("res/purples2.png")
purples3 = image.load("res/purples3.png")
purples4 = image.load("res/purples4.png")
red = image.load("res/red.png")
reds1 = image.load("res/reds1.png")
reds2 = image.load("res/reds2.png")
reds3 = image.load("res/reds3.png")
reds4 = image.load("res/reds4.png")
white = image.load("res/white.png")
whites1 = image.load("res/whites1.png")
whites2 = image.load("res/whites2.png")
whites3 = image.load("res/whites3.png")
whites4 = image.load("res/whites4.png")
yellow = image.load("res/yellow.png")
yellows1 = image.load("res/yellows1.png")
yellows2 = image.load("res/yellows2.png")
yellows3 = image.load("res/yellows3.png")
yellows4 = image.load("res/yellows4.png")
dest1 = image.load("res/dest1.png")
dest2 = image.load("res/dest2.png")
dest3 = image.load("res/dest3.png")
dest4 = image.load("res/dest4.png")

screen.fillrect(0,0,screen.width(),screen.height(),black50)
splash:draw(80,60) -- splash page
screen.update()

ops = io.input("ops.lua") -- load highscore & settings
highscore = tonumber(ops:read("*l")) -- highscore
if tonumber(ops:read("*l")) == 1 then
	sndon = true -- sound on boolean
else
	sndon = false
end
if tonumber(ops:read("*l")) == 1 then
	wrigon = true -- wriggle on boolean
else
	wrigon = false
end
ops:close()

wavclash = wav.load("snd/clash.wav") -- load sound files
wavdestroy = wav.load("snd/destroy.wav")
wavswap = wav.load("snd/swap.wav")
wavfall = wav.load("snd/fall.wav")

gridall = {1,1,1,2,1,3,1,4,1,5,1,6,1,7,1,8,
2,1,2,2,2,3,2,4,2,5,2,6,2,7,2,8,
3,1,3,2,3,3,3,4,3,5,3,6,3,7,3,8,
4,1,4,2,4,3,4,4,4,5,4,6,4,7,4,8,
5,1,5,2,5,3,5,4,5,5,5,6,5,7,5,8,
6,1,6,2,6,3,6,4,6,5,6,6,6,7,6,8,
7,1,7,2,7,3,7,4,7,5,7,6,7,7,7,8,
8,1,8,2,8,3,8,4,8,5,8,6,8,7,8,8} -- set default variables

math.randomseed(os.time()) -- establish better random seed

function drawmenu() -- draw main menu
	menu:draw(0,0) -- draw background
	local scorelen = string.len(string.format("%u", highscore))
	local pscorelen = scorelen * 9 -- calc score pixel length & redraw score
	if pscorelen >= 142 then -- crop score length if bigger than available space
		local strscore = string.sub((string.format("%d", highscore/(10^(scorelen-1)))), 0, scorelen-4).."x10"
		text.draw(49,339,strscore,"right", 182)
		text.size(8)
		text.draw(182, 339, scorelen - 1, "center", 191)
	else
		text.draw(49, 339, highscore, "right", 191)-- draw high score display
	end
	if sndon then -- draw current settings icons
		soundon:draw(87, 291)
	else
		soundoff:draw(87, 291)
	end
	if wrigon then
		hinton:draw(132, 291)
	else
		hintoff:draw(132, 291)
	end
	text.size(10)
	text.draw(160, 387, version, "right", 238)
	text.draw(160, 387, version, "right", 238)
	text.size(16)
end

function drawdialog() -- draw dialog box
	screen.fillrect(0,0,screen.width(),screen.height(),black50)
	dialog:draw(0,152)
	screen.update()
	local ret = false
	while true do
		if (control.read() == 1) then
			if (control.isButton() == 1) and (button.click() == 1) then
				ret = true
				break
			elseif (control.isTouch() == 1) and (touch.click() == 1) then
				local x, y = touch.pos()
				if (x > 23) and (x < 100) and (y > 210) and (y < 239) then
					ret = true
					break
				elseif (x > 139) and (x < 215) and (y > 220) and (y < 239) then
					break
				end
			end
		else
			os.wait(10)
		end
	end
	x = 0
	y = 0
	return ret
end

function drawgems(match) -- draw all gems in grid
	match = match or {}
	local dest = false
	board:draw(0,0)
	local ss = ""
	if shinestage ~= 0 then -- if gem is shining, draw appropriate frame for gem type
		if shinestage == 1 then
			if column[shinex][shiney].gemtype == 1 then
				blues1:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 2 then
				greens1:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 3 then
				oranges1:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 4 then
				purples1:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 5 then
				reds1:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 6 then
				whites1:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 7 then
				yellows1:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			end
		elseif shinestage == 2 then
			if column[shinex][shiney].gemtype == 1 then
				blues2:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 2 then
				greens2:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 3 then
				oranges2:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 4 then
				purples2:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 5 then
				reds2:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 6 then
				whites2:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 7 then
				yellows2:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			end
		elseif shinestage == 3 then
			if column[shinex][shiney].gemtype == 1 then
				blues3:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 2 then
				greens3:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 3 then
				oranges3:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 4 then
				purples3:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 5 then
				reds3:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 6 then
				whites3:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 7 then
				yellows3:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			end
		elseif shinestage == 4 then
			if column[shinex][shiney].gemtype == 1 then
				blues4:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 2 then
				greens4:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 3 then
				oranges4:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 4 then
				purples4:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 5 then
				reds4:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 6 then
				whites4:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			elseif column[shinex][shiney].gemtype == 7 then
				yellows4:draw(column[shinex][shiney].drawlocix, column[shinex][shiney].drawlociy)
			end
		end
	end
	if (deststage ~= 0) and (#match > 0) then -- if gem is being destroyed, draw appropriate dest frames
		for f = 1, #match, 2 do
			if deststage == 1 then
				dest1:draw(column[(match[f])][(match[(f+1)])].drawlocix, column[(match[f])][(match[(f+1)])].drawlociy)
			elseif deststage == 2 then
				dest2:draw(column[(match[f])][(match[(f+1)])].drawlocix, column[(match[f])][(match[(f+1)])].drawlociy)
			elseif deststage == 3 then
				dest3:draw(column[(match[f])][(match[(f+1)])].drawlocix, column[(match[f])][(match[(f+1)])].drawlociy)
			elseif deststage == 4 then
				dest4:draw(column[(match[f])][(match[(f+1)])].drawlocix, column[(match[f])][(match[(f+1)])].drawlociy)
			end
		end
	end
	for gx = 1, 8, 1 do -- iterate through grid and run draw on each gem that isn't shine or destroyed
		for gy = 1, 8, 1 do
			if column[gx][gy] ~= nil then
				if #match ~= 0 then
					for f = 1, #match, 2 do
						if (gx == match[f]) and (gy == match[(f+1)]) then
							dest = true
						end
					end
				end
				if (column[gx][gy].drawlociy > 90) and (shinestage == 0 or gx ~= shinex or gy ~= shiney) and (not dest) then
					if column[gx][gy].gemtype == 1 then
						blue:draw(column[gx][gy].drawlocix, column[gx][gy].drawlociy)
					elseif column[gx][gy].gemtype == 2 then
						green:draw(column[gx][gy].drawlocix, column[gx][gy].drawlociy)
					elseif column[gx][gy].gemtype == 3 then
						orange:draw(column[gx][gy].drawlocix, column[gx][gy].drawlociy)
					elseif column[gx][gy].gemtype == 4 then
						purple:draw(column[gx][gy].drawlocix, column[gx][gy].drawlociy)
					elseif column[gx][gy].gemtype == 5 then
						red:draw(column[gx][gy].drawlocix, column[gx][gy].drawlociy)
					elseif column[gx][gy].gemtype == 6 then
						white:draw(column[gx][gy].drawlocix, column[gx][gy].drawlociy)
					elseif column[gx][gy].gemtype == 7 then
						yellow:draw(column[gx][gy].drawlocix, column[gx][gy].drawlociy)
					end
				end
			end
			dest = false
		end
	end
	board:draw(0,0,0,0,240,120)
	drawscore()
end

function drawscore() -- draw score on board
	local scorelen = string.len(string.format("%u", score))
	local pscorelen = scorelen * 9 -- calc score pixel length & redraw score
	scorebar:draw(0,97)
	if pscorelen >= 230 then -- if score pixels are too many for score bar image, compact score display
		local strscore = string.sub((string.format("%d", score/(10^(scorelen-1)))), 0, scorelen-4).."x10"
		text.draw(5,98,strscore,"right", 226)
		text.size(8)
		text.draw(226, 98, scorelen - 1, "center", 235)
		text.size(16)
	else
		text.draw(5,98,score,"right",235)	
	end
end

function drawloci(tbl) -- check if gems at table of locations are at draw locations
	local ret = {}
	for i = 1, #tbl, 2 do
		if column[(tbl[i])][(tbl[i+1])] ~= nil then -- does not return nil values from table
			if (column[(tbl[i])][(tbl[i+1])].drawlocix ~= (tbl[i] - 1) * 30) or (column[(tbl[i])][(tbl[i+1])].drawlociy ~= (((tbl[i+1]) - 1) * 30) + 120) then
				table.insert(ret, tbl[i])
				table.insert(ret, tbl[i+1])
			end
		end
	end
	return ret
end

function matchgems() -- search grid for matching lines of three, return table of locations, else false
	local ret = {}
	for gx = 1, 8, 1 do -- iterate through grid
		for gy = 1, 8, 1 do
			if (column[gx][gy] ~= nil) then
				if (gx > 1) and (gx < 8) and (column[(gx-1)][gy] ~= nil) and (column[(gx+1)][gy] ~= nil) then -- if horizontal line exists, add grid locations of matching gems to return table
					if ((column[gx][gy].gemtype) == (column[(gx-1)][gy].gemtype)) and ((column[gx][gy].gemtype) == (column[(gx+1)][gy].gemtype)) then
						table.insert(ret,(gx-1))
						table.insert(ret,gy)
						table.insert(ret,gx)
						table.insert(ret,gy)
						table.insert(ret,(gx+1))
						table.insert(ret,gy)
					end
				end
				if (gy > 1) and (gy < 8) and (column[gx][(gy-1)] ~= nil) and (column[gx][(gy+1)] ~= nil) then -- if vertical line exists, add grid locations of matching gems to return table
					if ((column[gx][gy].gemtype) == (column[gx][(gy-1)].gemtype)) and ((column[gx][gy].gemtype) == (column[gx][(gy+1)].gemtype)) then
						table.insert(ret,gx)
						table.insert(ret,(gy-1))
						table.insert(ret,gx)
						table.insert(ret,gy)
						table.insert(ret,gx)
						table.insert(ret,(gy+1))
					end
				end
			end
		end
	end
	if (#ret ~= 0) then
		for i = 1, #ret, 2 do -- iterate through table comparing grid locations and remove duplicates
			for n = (i + 2), #ret, 2 do
				if (ret[i] == ret[n]) and (ret[(i+1)] == ret[(n+1)]) then
					table.remove(ret,n)
					table.remove(ret,n) -- removes y position, at same 'n' because the x position has already gone
					n = n - 2
				end
			end
		end
	end
	return ret
end

function newgems() -- create random gems at nil points in grid
	local i = 0
	for gx = 1, 8, 1 do -- iterate through grid
		for gy = 8, 1, -1 do
			if column[gx][gy] == nil then
				local t = math.random(1,7) -- random number for gem type
				if (t - math.floor(t)) >= 0.5 then -- round number
					t = math.ceil(t)
				elseif (t - math.floor(t)) < 0.5 then
					t = math.floor(t)
				end
				column[gx][gy] = {gemtype = t,
					drawlocix = (gx-1) * 30,
					drawlociy = (90 + (accelstage * 2))}
				i = i + 1
				if i > 1 then
					column[gx][gy].drawlociy = column[gx][gy].drawlociy - ((i - 1) * 30)
				end
			end
		end
		i = 0
	end
end

function movesgems() -- check if moves can still be made, return table of locations for moves, else return false
	local ret = {}
	for gx = 1, 8, 1 do
		for gy = 1, 8, 1 do
			if (gx > 3) then -- left3
				if (column[gx][gy].gemtype == column[(gx-2)][gy].gemtype) and (column[gx][gy].gemtype == column[(gx-3)][gy].gemtype) then
					table.insert(ret, gx)
					table.insert(ret, gy)
					table.insert(ret, (gx-1))
					table.insert(ret, gy)
				end
			end
			if (gx < 6) then --right3
				if (column[gx][gy].gemtype == column[(gx+2)][gy].gemtype) and (column[gx][gy].gemtype == column[(gx+3)][gy].gemtype) then
					table.insert(ret, gx)
					table.insert(ret, gy)
					table.insert(ret, (gx+1))
					table.insert(ret, gy)
				end
			end
			if (gy > 3) then -- up3
				if (column[gx][gy].gemtype == column[gx][(gy-2)].gemtype) and (column[gx][gy].gemtype == column[gx][(gy-3)].gemtype) then
					table.insert(ret, gx)
					table.insert(ret, gy)
					table.insert(ret, gx)
					table.insert(ret, (gy-1))
				end
			end
			if (gy < 6) then -- down3
				if (column[gx][gy].gemtype == column[gx][(gy+2)].gemtype) and (column[gx][gy].gemtype == column[gx][(gy+3)].gemtype) then
					table.insert(ret, gx)
					table.insert(ret, gy)
					table.insert(ret, gx)
					table.insert(ret, (gy+1))
				end
			end
			if (gx > 2) then -- left2
				if (gy ~= 1) then -- left1, up1, left2, up1
					if (column[gx][gy].gemtype == column[(gx-1)][(gy-1)].gemtype) and (column[gx][gy].gemtype == column[(gx-2)][(gy-1)].gemtype) then
						table.insert(ret, gx)
						table.insert(ret, gy)
						table.insert(ret, gx)
						table.insert(ret, (gy-1))
					end
				end
				if (gy ~= 8) then -- left1, down1, left2, down1
					if (column[gx][gy].gemtype == column[(gx-1)][(gy+1)].gemtype) and (column[gx][gy].gemtype == column[(gx-2)][(gy+1)].gemtype) then
						table.insert(ret, gx)
						table.insert(ret, gy)
						table.insert(ret, gx)
						table.insert(ret, (gy+1))
					end
				end
			end
			if (gx < 7) then -- right2
				if (gy ~= 1) then -- right1, up1, right2, up1
					if (column[gx][gy].gemtype == column[(gx+1)][(gy-1)].gemtype) and (column[gx][gy].gemtype == column[(gx+2)][(gy-1)].gemtype) then
						table.insert(ret, gx)
						table.insert(ret, gy)
						table.insert(ret, gx)
						table.insert(ret, (gy-1))
					end
				end
				if (gy ~= 8) then --right1, down1, right2, down1
					if (column[gx][gy].gemtype == column[(gx+1)][(gy+1)].gemtype) and (column[gx][gy].gemtype == column[(gx+2)][(gy+1)].gemtype) then
						table.insert(ret, gx)
						table.insert(ret, gy)
						table.insert(ret, gx)
						table.insert(ret, (gy+1))
					end
				end
			end
			if (gx ~= 1) then -- left1
				if (gy > 2) then -- left1, up1, left1, up2
					if (column[gx][gy].gemtype == column[(gx-1)][(gy-1)].gemtype) and (column[gx][gy].gemtype == column[(gx-1)][(gy-2)].gemtype) then
						table.insert(ret, gx)
						table.insert(ret, gy)
						table.insert(ret, (gx-1))
						table.insert(ret, gy)
					end
				end
				if (gy < 7) then -- left1, down1, left1, down2
					if (column[gx][gy].gemtype == column[(gx-1)][(gy+1)].gemtype) and (column[gx][gy].gemtype == column[(gx-1)][(gy+2)].gemtype) then
						table.insert(ret, gx)
						table.insert(ret, gy)
						table.insert(ret, (gx-1))
						table.insert(ret, gy)
					end
				end
				if (gy ~= 1) then
					if (gy ~= 8) then -- left1, up1, left1, down1
						if (column[gx][gy].gemtype == column[(gx-1)][(gy-1)].gemtype) and (column[gx][gy].gemtype == column[(gx-1)][(gy+1)].gemtype) then
							table.insert(ret, gx)
							table.insert(ret, gy)
							table.insert(ret, (gx-1))
							table.insert(ret, gy)
						end
					end
					if (gx ~= 8) then -- left1, up1, right1, up1
						if (column[gx][gy].gemtype == column[(gx-1)][(gy-1)].gemtype) and (column[gx][gy].gemtype == column[(gx+1)][(gy-1)].gemtype) then
							table.insert(ret, gx)
							table.insert(ret, gy)
							table.insert(ret, gx)
							table.insert(ret, (gy-1))
						end
					end
				end
				if (gy ~= 8) then
					if (gx ~= 8) then -- left1, down1, right1, down1
						if (column[gx][gy].gemtype == column[(gx-1)][(gy+1)].gemtype) and (column[gx][gy].gemtype == column[(gx+1)][(gy+1)].gemtype) then
							table.insert(ret, gx)
							table.insert(ret, gy)
							table.insert(ret, gx)
							table.insert(ret, (gy+1))
						end
					end
				end
			end
			if (gx ~= 8) then -- right1
				if (gy > 2) then -- right1, up1, right1, up2
					if (column[gx][gy].gemtype == column[(gx+1)][(gy-1)].gemtype) and (column[gx][gy].gemtype == column[(gx+1)][(gy-2)].gemtype) then
						table.insert(ret, gx)
						table.insert(ret, gy)
						table.insert(ret, (gx+1))
						table.insert(ret, gy)
					end
				end
				if (gy < 7) then -- right1, down1, right1, down2
					if (column[gx][gy].gemtype == column[(gx+1)][(gy+1)].gemtype) and (column[gx][gy].gemtype == column[(gx+1)][(gy+2)].gemtype) then
						table.insert(ret, gx)
						table.insert(ret, gy)
						table.insert(ret, (gx+1))
						table.insert(ret, gy)
					end
				end
				if (gy ~= 1) then
					if (gy ~= 8) then -- right1, up1, right1, down1
						if (column[gx][gy].gemtype == column[(gx+1)][(gy-1)].gemtype) and (column[gx][gy].gemtype == column[(gx+1)][(gy+1)].gemtype) then
							table.insert(ret, gx)
							table.insert(ret, gy)
							table.insert(ret, (gx+1))
							table.insert(ret, gy)
						end
					end
				end
			end
		end
	end
	return ret
end

function exchangegems(tbl, x, y, x1, y1) -- check if gems can be exchanged, do so if true, else animate clash
	local ret = false
	local increment = 6
	local match = false
	for i = 1, #tbl-3, 2 do -- loop searches grid locations table to match x, y 
		if (((tbl[i] == x1) and (tbl[(i+1)] == y1) and (tbl[(i+2)] == x) and (tbl[(i+3)] == y)) or ((tbl[i] == x) and (tbl[(i+1)] == y) and (tbl[(i+2)] == x1) and (tbl[(i+3)] == y1))) then
			match = true
			break
		end
	end
	if match then
		if sndon then
			wavswap:play() -- play swap sound
		end
		local tempstore = column[x][y] -- swap x,y data with x1,y1
		column[x][y] = column[x1][y1]
		column[x1][y1] = tempstore
		-- increment each gems location closer to their draw location until it matches
		while (#drawloci({x1,y1}) ~= 0) do
			if (column[x1][y1].drawlocix < ((x1 - 1) * 30)) then
				if (column[x1][y1].drawlocix + increment > ((x1 - 1) * 30)) then
					column[x1][y1].drawlocix = ((x1 - 1) * 30)
					column[x][y].drawlocix = ((x - 1) * 30)
				else
					column[x1][y1].drawlocix = column[x1][y1].drawlocix + increment
					column[x][y].drawlocix = column[x][y].drawlocix - increment
				end
			elseif (column[x1][y1].drawlocix > ((x1 - 1) * 30)) then
				if (column[x1][y1].drawlocix - increment < ((x1 - 1) * 30)) then
					column[x1][y1].drawlocix = ((x1 - 1) * 30)
					column[x][y].drawlocix = ((x - 1) * 30)
				else
					column[x1][y1].drawlocix = column[x1][y1].drawlocix - increment
					column[x][y].drawlocix = column[x][y].drawlocix + increment
				end
			elseif (column[x1][y1].drawlociy < (((y1 - 1) * 30) + 120)) then
				if (column[x1][y1].drawlociy + increment > (((y1 - 1) * 30) + 120)) then
					column[x1][y1].drawlociy = (((y1 - 1) * 30) + 120)
					column[x][y].drawlociy = (((y - 1) * 30) + 120)
				else
					column[x1][y1].drawlociy = column[x1][y1].drawlociy + increment
					column[x][y].drawlociy = column[x][y].drawlociy - increment
				end
			elseif (column[x1][y1].drawlociy > (((y1 - 1) * 30) + 120)) then
				if (column[x1][y1].drawlociy - increment < (((y1 - 1) * 30) + 120)) then
					column[x1][y1].drawlociy = (((y1 - 1) * 30) + 120)
					column[x][y].drawlociy = (((y - 1) * 30) + 120)
				else
					column[x1][y1].drawlociy = column[x1][y1].drawlociy - increment
					column[x][y].drawlociy = column[x][y].drawlociy + increment
				end
			end
			drawgems()
			screen.update()
			ret = true
		end
	else
		if sndon then
			wavclash:play() -- play clash sound
		end
		local destframeimage = nil
		local destframe = 1
		if x ~= x1 then
			destx = math.min(((x1 - 1) * 30), ((x - 1) * 30)) + 15
		else
			destx = (x1 - 1) * 30
		end
		if y ~= y1 then
			desty = math.min((((y1 - 1) * 30) + 120), (((y - 1) * 30) + 120)) + 15
		else
			desty = (((y - 1) * 30) + 120)
		end
		for q = 1, 4, 1 do
			drawgems()
			if destframe < 5 then
				if destframe == 1 then
					dest1:draw(destx,desty)
				elseif destframe == 2 then
					dest2:draw(destx,desty)
				elseif destframe == 3 then
					dest3:draw(destx,desty)
				elseif destframe == 4 then
					dest4:draw(destx,desty)
				end
				destframe = destframe + 1
			else
				destdraw = false
			end
			os.wait(5)
			screen.update()
			ret = false
		end
	end
	return ret
end

function wrigglegem(x, y) -- wriggle gem at location
	if wrigstage < 7 then
		wrigstage = wrigstage + 1 -- increment wriggle stage
		if wrigstage == 1 then -- alter draw pos dependant on wriggle stage
			column[x][y].drawlocix = column[x][y].drawlocix + 3
			column[x][y].drawlociy = column[x][y].drawlociy + 1
		elseif wrigstage == 2 then
			column[x][y].drawlocix = column[x][y].drawlocix - 6
			column[x][y].drawlociy = column[x][y].drawlociy - 2
		elseif wrigstage == 3 then
			column[x][y].drawlocix = column[x][y].drawlocix + 4
			column[x][y].drawlociy = column[x][y].drawlociy + 4
		elseif wrigstage == 4 then
			column[x][y].drawlocix = column[x][y].drawlocix - 2
			column[x][y].drawlociy = column[x][y].drawlociy - 6
		elseif wrigstage == 5 then
			column[x][y].drawlocix = column[x][y].drawlocix + 1
			column[x][y].drawlociy = column[x][y].drawlociy + 7
		elseif wrigstage == 6 then
			column[x][y].drawlocix = column[x][y].drawlocix + 1
			column[x][y].drawlociy = column[x][y].drawlociy - 8
		end
	else
		wrigstage = 0 -- reset wriggle stage, draw pos, and wriggle active
		column[x][y].drawlocix = (x - 1) * 30
		column[x][y].drawlociy = ((y - 1) * 30) + 120
		wriggleactive = false
		drawgems()
		screen.update()
	end
end

function shinegem(x, y) -- function shinegem(x,y)
	if shinestage ~= 4 then -- if shine stage is not max then
		shinestage = shinestage + 1 -- increment shine stage
	else
		shinestage = 0 -- reset shine stage
	end
end

function fallgems(tbl) -- moves gems down to nil positions, increases acceleration, sets draw position according to acceleration from previous position
	local ylow = 0
	if accelstage == 0 then
		accelstage = accelstage +1
	elseif accelstage < 10 then
		accelstage = accelstage * 2
	end
	for z = 1, 8, 1 do -- iterate through grid
		for i = 1, #tbl, 2 do -- iterate through table of grid locations
			if (tbl[i] == z) then
				if (tbl[(i+1)] > ylow) then
					ylow = tbl[(i+1)]
				end
			end
		end
		for n = ylow, 1, (-1) do -- check grid locations below table entry and fall gems to new locations if nil below
			if (column[z][n] ~= nil) then
				for g = n, 7, 1 do -- fall grid spaces until no longer nil below current location
					if (column[z][(g+1)] == nil) then
						column[z][(g+1)] = column[z][g]
						column[z][g] = nil
					end
				end
			end
		end
		ylow = 0
	end
	ylow = 0
	for z = 1, 8, 1 do -- iterate through grid
		for i = 1, #tbl, 2 do -- iterate through table of grid locations
			if (tbl[i] == z) then
				if (tbl[(i+1)] > ylow) then
					ylow = tbl[(i+1)]
				end
			end
		end
		for n = ylow, 1, (-1) do -- check grid location and above for gems and move them according to accelstage
			if (column[z][n] ~= nil) then
				if (#drawloci({z,n}) ~= 0) then -- if gem is not drawn where it belongs, increment acceleration and then calculate where to move the draw position to
					if ((column[z][n].drawlociy + (accelstage * 2)) > ((n - 1) * 30) + 120) then
						column[z][n].drawlociy = ((n - 1) * 30) + 120
					else
						column[z][n].drawlociy = column[z][n].drawlociy + (accelstage * 2)
					end
				end
			end
		end
		ylow = 0
	end
end

function destroygems(tbl) -- increment destroy stage until max reached, set score & score multiplier, draw score
	if sndon then
		wavdestroy:play()-- play destroy sound
	end
	while (column[(tbl[1])][(tbl[2])] ~= nil) do -- while table entry is not empty, run destroy on passed table of grid locations
		deststage = deststage + 1
		if deststage == 5 then
			for i =1, #tbl, 2 do
				column[(tbl[i])][(tbl[(i+1)])] = nil
			end
		end
		os.wait(40)
		drawgems(tbl)
		screen.update()
	end
	score = math.floor(score + ((((#tbl / 2) + (((#tbl / 2)-3)*1.25)) * scoremulti) * 10)) -- increase score by number of stones destroyed x multiplier
	scoremulti = scoremulti + (scoremulti * 0.2) -- increase multiplier
	drawscore()
	deststage = 0
end

os.wait(2500) -- splash wait
math.randomseed((os.time() * math.random()))

screen.clear()

screen.orientation(1) -- change screen orientation

screen.backlight(100) -- set backlight to avoid crashing.

splash:close()

while true do -- main program loop
	drawmenu()-- run draw main menu function
	screen.update()
	if (control.read() == 1) then
		if (control.isButton() == 1) and (button.click() == 1) then -- start touch listener
			if drawdialog() then
				break
			end
		elseif (control.isTouch() == 1) and (touch.click() == 1) then
			tx, ty = touch.pos() -- get touch pos
			if (tx > 44) and (tx < 195) and (ty > 252) and (ty < 281) then -- quit
				if drawdialog() then
					break
				end
			elseif (tx > 44) and (tx < 195) and (ty > 214) and (ty < 243) then -- options menu
				optionmenu = image.load("res/optionmenu.png")
				optionmenu:draw(0,0)
				text.size(10)
				text.draw(160, 387, version, "right", 238)
				text.draw(160, 387, version, "right", 238)
				text.size(16)
				if sndon then
					soundon:draw(166,227)
				else
					soundoff:draw(166,227)
				end
				if wrigon then
					hinton:draw(166,275)
				else
					hintoff:draw(166,275)
				end
				screen.update()
				while true do -- option menu loop listener
					if (control.read() == 1) then
						if (control.isButton() == 1) and (button.click() == 1) then -- start touch listener
							break
						elseif (control.isTouch() == 1) and (touch.click() == 1) then
							tx, ty = touch.pos()
							if (tx > 44) and (tx < 195) and (ty > 328) and (ty < 397) then -- back button
								break
							elseif (tx > 163) and (tx < 190) and (ty > 223) and (ty < 250) then -- sound on/off
								if sndon then -- set sound option boolean
									sndon = false
								else
									sndon = true
								end
								optionmenu:draw(0,0)
								text.size(10)
								text.draw(160, 387, version, "right", 238)
								text.draw(160, 387, version, "right", 238)
								text.size(16)
								if sndon then
									soundon:draw(166,227)
								else
									soundoff:draw(166,227)
								end
								if wrigon then
									hinton:draw(166,275)
								else
									hintoff:draw(166,275)
								end
								screen.update()
							elseif (tx > 163) and (tx < 190) and (ty > 272) and (ty < 299) then -- wriggle on/off
								if wrigon then -- set and save hint option boolean
									wrigon = false
								else
									wrigon = true
								end
								optionmenu:draw(0,0)
								text.size(10)
								text.draw(160, 387, version, "right", 238)
								text.draw(160, 387, version, "right", 238)
								text.size(16)
								if sndon then
									soundon:draw(166,227)
								else
									soundoff:draw(166,227)
								end
								if wrigon then
									hinton:draw(166,275)
								else
									hintoff:draw(166,275)
								end
								screen.update()
							end
						end
					else
						os.wait(10)
					end
				end
				if sndon then
					sndwrite = 1
				else
					sndwrite = 0
				end
				if wrigon then
					wrigwrite = 1
				else
					wrigwrite = 0
				end
				ops = io.output("ops.lua") -- save options
				ops:write(highscore,"\n",sndwrite,"\n",wrigwrite,"\n0")
				ops:close()
				optionmenu:close()
			elseif (tx > 44) and (tx < 195) and (ty > 176) and (ty < 205) then -- new game
				column = {
					{nil, nil, nil, nil, nil, nil, nil, nil},
					{nil, nil, nil, nil, nil, nil, nil, nil},
					{nil, nil, nil, nil, nil, nil, nil, nil},
					{nil, nil, nil, nil, nil, nil, nil, nil},
					{nil, nil, nil, nil, nil, nil, nil, nil},
					{nil, nil, nil, nil, nil, nil, nil, nil},
					{nil, nil, nil, nil, nil, nil, nil, nil},
					{nil, nil, nil, nil, nil, nil, nil, nil}
				} -- establish grid tables
				gemactive = false -- reset all variables
				shinex = 0
				shiney = 0
				wriggleactive = false
				wrigglewait = 0
				wrigx = 0
				wrigy = 0
				score = 0
				scoremulti = 1
				deststage = 0
				shinestage = 0
				wrigstage = 0
				accelstage = 0
				newgems() -- run new gems function
				board:draw(0,0)
				drawscore() -- draw score
				gameend = false
				while (#drawloci(gridall) ~= 0) do -- loop runs until all gems at draw locations
					if sndon then
						wavfall:play() -- play fall sound
					end
					while (#drawloci(gridall) ~= 0) do -- loop fall function on matching lines function table until all gems at draw location
						fallgems(gridall)-- run draw gems function
						drawgems()
						screen.update()
					end
					accelstage = 0 -- reset acceleration
					matchtbl = matchgems() -- run check for matching lines function
					if (#matchtbl ~= 0) then
						destroygems(matchtbl)-- run destroy on matching lines table
						fallgems(gridall)
						drawgems()
						screen.update()
					end
					newgems()-- run new gems function
					fallgems(matchtbl)-- run fall function passing table from matching lines function
					drawgems()
					screen.update()
					matchtbl = matchgems()
					if (#matchtbl == 0) then -- if none, break
						break
					end
				end
				newgems()
				accelstage = 0 -- reset acceleration
				if (#drawloci(gridall) ~= 0) and sndon then
					wavfall:play() -- play fall sound
				end
				while (#drawloci(gridall) ~= 0) do -- loop fall function  until all gems at draw location
					fallgems(gridall)-- run draw gems function
					drawgems()
					screen.update()
				end
				accelstage = 0 -- reset acceleration
				scoremulti = 1 -- reset score multiplier = 1
				while true do -- ingame main listening loop
					if (control.read() == 1) then
						if (control.isButton() == 1) and (button.click() == 1) then -- quit game
							if drawdialog() then -- yes/no dialog
								if (score > highscore) then
									highscore = score
									if sndon then
										sndwrite = 1
									else
										sndwrite = 0
									end
									if wrigon then
										wrigwrite = 1
									else
										wrigwrite = 0
									end
									ops = io.output("ops.lua") -- save highscore
									ops:write(highscore,"\n",sndwrite,"\n",wrigwrite,"\n0")
									ops:close()
								end
								break -- quit game
							else
								board:draw(0,0)
								drawgems() -- run draw gems function
								drawscore() -- draw score
								screen.update()
							end
						elseif (control.isTouch() == 1) and (touch.click() == 1) then
							tx, ty = touch.pos()
							if (tx > 8) and (tx < 35) and (ty > 9) and (ty < 36) then -- back button
								if drawdialog() then -- yes/no dialog
									if (score > highscore) then
										highscore = score
										if sndon then
											sndwrite = 1
										else
											sndwrite = 0
										end
										if wrigon then
											wrigwrite = 1
										else
											wrigwrite = 0
										end
										ops = io.output("ops.lua") -- save highscore
										ops:write(highscore,"\n",sndwrite,"\n",wrigwrite,"\n0")
										ops:close()
									end
									break -- quit game
								else
									board:draw(0,0)
									drawgems() -- run draw gems function
									drawscore() -- draw score
									screen.update()
								end
							elseif (ty > 119) and (ty < 360) then -- if touch is in grid space then run equation on location to work out which grid location it's on
								gridx = math.ceil((tx/30)) -- set grid location values
								gridy = math.ceil(((ty - 120)/30))
								if gridx == 0 then
									gridx = 1
								end
								if gridy == 0 then
									gridy = 1
								end
								if wriggleactive then
									wriggleactive = false -- set wriggle active = false
									wrigglewait = 0 -- reset wrigglewait
									column[wrigx][wrigy].drawlocix = (wrigx - 1) * 30 -- reset draw position at wriggle location x,y
									column[wrigx][wrigy].drawlociy = ((wrigy - 1) * 30) + 120
									wrigstage = 0
									wrigx = 0
									wrigy = 0
								end
								column[gridx][gridy].drawlocix = (gridx - 1) * 30 -- set draw location of grid location gem back to default
								column[gridx][gridy].drawlociy = ((gridy - 1) * 30) + 120
								if gemactive then -- if gem active boolean then
									shinestage = 0
									if ((gridx == shinex - 1) and (gridy == shiney)) or ((gridx == shinex + 1) and (gridy == shiney)) or ((gridy == shiney - 1) and (gridx == shinex)) or ((gridy == shiney + 1) and (gridx == shinex)) then -- if touch is on gem adjacent to grid location then
										if exchangegems(movesgems(),shinex,shiney,gridx,gridy) then -- set grid location gem frame back to default
											math.randomseed(os.time() * math.random())
											matchtable = matchgems()
											--os.wait(5)
											if (#matchtable ~= 0) then
												destroygems(matchtable) -- destroy matching gems
											end
											fallgems(gridall) -- run fall gems function
											newgems() -- run new gems function
											drawgems()-- run draw gems function
											--os.wait(5)
											screen.update()
											while (#drawloci(gridall) ~= 0) do -- loop runs until all gems at draw locations
												if sndon then
													wavfall:play() -- play fall sound
												end
												while (#drawloci(gridall) ~= 0) do -- loop fall function on matching lines function table until all gems at draw location
													fallgems(gridall)-- run draw gems function
													drawgems()
													--os.wait(5)
													screen.update()
												end
												matchtbl = matchgems() -- run check for matching lines function
												accelstage = 0 -- reset acceleration
												if (#matchtbl ~= 0) then
													destroygems(matchtbl)-- run destroy on matching lines table
													fallgems(gridall)
													drawgems()
													os.wait(5)
													screen.update()
												end
												newgems()-- run new gems function
												fallgems(matchtbl)-- run fall function passing table from matching lines function
												drawgems()
												--os.wait(5)
												screen.update()
												matchtbl = matchgems()
												if (#matchtbl == 0) then -- if none, break
													break
												end
											end
											newgems()
											accelstage = 0 -- reset acceleration
											if (#drawloci(gridall) ~= 0) and sndon then
												wavfall:play() -- play fall sound
											end
											while (#drawloci(gridall) ~= 0) do -- loop fall function  until all gems at draw location
												fallgems(gridall)-- run draw gems function
												drawgems()
												--os.wait(5)
												screen.update()
											end
											accelstage = 0 -- reset acceleration
											scoremulti = 1 -- reset score multiplier = 1
										end
									end
									gemactive = false -- set gem active boolean = false
									shinex = 0
									shiney = 0
									drawgems()
									screen.update()
								else -- if not gem active boolean, gem active boolean = true
									gemactive = true
									shinex = gridx
									shiney = gridy
								end
							else
								if gemactive then
									gemactive = false -- set gem active boolean = false
									drawgems()
									screen.update()
								end
							end
						end
					end
					if (#movesgems() == 0) then -- run function to check if no moves left
						if (score > highscore) then
							highscore = score
							if sndon then
								sndwrite = 1
							else
								sndwrite = 0
							end
							if wrigon then
								wrigwrite = 1
							else
								wrigwrite = 0
							end
							ops = io.output("ops.lua") -- save highscore
							ops:write(highscore,"\n",sndwrite,"\n",wrigwrite,"\n0")
							ops:close()
						end
						if sndon then
							wavdestroy:play() -- play destroy sound
						end
						for i = 1, 5, 1 do -- loop runs 4 times
							board:draw(0,0)
							if i < 5 then
								for c = 1, 8, 1 do
									for r = 1, 8, 1 do
										if i == 1 then
											dest1:draw(((c-1)*30), (((r-1)*30)+120))
										elseif i == 2 then
											dest2:draw(((c-1)*30), (((r-1)*30)+120))
										elseif i == 3 then
											dest3:draw(((c-1)*30), (((r-1)*30)+120))
										elseif i == 4 then
												dest4:draw(((c-1)*30), (((r-1)*30)+120))
										end
									end
								end
							end
							screen.fillrect(0,0,screen.width(),screen.height(),black50)
							gameover:draw(0,152) -- draw game over message
							os.wait(2)
							screen.update()
						end
						while true do -- wait for touch
							if (control.read() == 1) then
								if ((control.isTouch() == 1) and (touch.click() == 1)) or (control.isButton() == 1 and (button.click() == 1 or button.up() == 1 or button.hold() == 1)) then
									gameend = true
									break
								end
							else
								os.wait(10)
							end
						end
						if gameend then
							break
						end
					end
					if gemactive then -- if gem active = true
						shinegem(shinex,shiney) -- run shine on grid location
					else
						if wriggleactive then -- if wriggle active = true
							wrigglegem(wrigx,wrigy) -- run wriggle on wriggle location
						end
					end
					if gemactive or wriggleactive then -- if either gem active or wriggle active = true then draw gems function call
						board:draw(0,0)
						drawscore()
						drawgems()
						wrigglewait = 0
						os.wait(10)
						screen.update()
					elseif wrigon and (not gemactive) then -- elseif wriggle on = true and gemactive = false then
						os.wait(10) -- ingame wait
						wrigglewait = wrigglewait + 1 -- increment wriggle wait
						if wrigglewait > 750 then -- if wriggle wait > set time then
							wriggleactive = true -- wriggle active = true
							wrigglewait = 0
							movetable = movesgems()
							local u = (math.floor((math.random(1,#movetable))/2))*2 -- select random entry for wriggle
							if (u+2 <= #movetable) then
								wrigx = movetable[(u+1)]
								wrigy = movetable[(u+2)]
							else
								wrigx = movetable[(#movetable - 1)]
								wrigy = movetable[#movetable]
							end
						end
					else
						os.wait(10)
					end
				end -- end of ingame loop
			end
		end
	else
		os.wait(10)
	end
end -- end main loop

screen.clear()

screen.orientation(0) -- reset screen orientation

dialog:close() -- wipe images memory
hintoff:close()
hinton:close()
menu:close()
soundoff:close()
soundon:close()
board:close() -- close ingame image files
gameover:close()
scorebar:close()
blue:close()
blues1:close()
blues2:close()
blues3:close()
blues4:close()
green:close()
greens1:close()
greens2:close()
greens3:close()
greens4:close()
orange:close()
oranges1:close()
oranges2:close()
oranges3:close()
oranges4:close()
purple:close()
purples1:close()
purples2:close()
purples3:close()
purples4:close()
red:close()
reds1:close()
reds2:close()
reds3:close()
reds4:close()
white:close()
whites1:close()
whites2:close()
whites3:close()
whites4:close()
yellow:close()
yellows1:close()
yellows2:close()
yellows3:close()
yellows4:close()
dest1:close()
dest2:close()
dest3:close()
dest4:close()

wavdestroy:close()
wavclash:close()
wavfall:close()
wavswap:close()